;
; To assemble, and link with 16-bit linker:
;
; c:\masm32\bin\ml.exe /c early2.asm
;
; c:\masm32\bin\link16.exe /TINY early2.obj
;
; file modified on Nov 2nd, 2005

.286
.model tiny

.code
   org 100h

_entry:
   jmp start

   message db 'Program Completed Successfully!$'
CRTParms label word
        dw 00d06h
        dw 03e07h
        dw 04109h
        dw 0ea10h
        dw 0ac11h
        dw 0df12h
        dw 00014h
        dw 0e715h
        dw 00616h
        dw 0e317h
CRT_PARM_LENGTH equ (($-CRTParms)/2)

; Taken from nrandom, 32-bit code.
; nrandom_seed is dd 12345678 (32-bit)

;    mov eax, nrandom_seed

;    xor edx, edx
;    mov ecx, 127773
;    div ecx
;    mov ecx, eax
;    mov eax, 16807
;    mul edx
;    mov edx, ecx
;    mov ecx, eax
;    mov eax, 2836
;    mul edx
;    sub ecx, eax
;    xor edx, edx
;    mov eax, ecx
;    mov nrandom_seed, ecx
;    div base

;    mov eax, edx

nrandom_seed dw 12345

start:

; This small routine, sets 320x240 256-color VGA mode.
        mov ax, 13h
        int 10h

        mov dx, 03c4h   ; SC_INDEX
        mov ax, 0604h
        out dx, ax

        mov ax, 0100h
        out dx, ax

        mov dx, 03c2h
        mov al, 0e3h
        out dx, al

        mov dx, 03c4h
        mov ax, 0300h
        out dx, ax

        mov dx, 03d4h
        mov al, 11h
        out dx, al

        inc dx
        in al, dx
        and al, 7fh
        out dx, al

        dec dx
        cld
        mov si, offset CRTParms
        mov cx, CRT_PARM_LENGTH
SetCRTParmsLoop:
        lodsw
        out dx, ax
        loop SetCRTParmsLoop

        mov dx, 03c4h
        mov ax, 0f02h
        out dx, ax

        mov ax, 0a000h
        mov es, ax
        sub di, di
        sub ax, ax
        mov cx, 8000h
        rep stosw
; We are now in 320x240 VGA 256-color mode!

; Wait for a keystroke.
        mov     ah,1
        int     21h

; Write Pixel Function notice (x,y,color) in comments

        mov cx, 239
here1:
        push cx
        mov ax, 80      ; ax = 80 (screen length)

; Generate Y random (not yet implemented)

        mov bx, cx      ; bx = cx (loop)
        mul bx          ; ax = (screen length * y)
        push ax
;        mov dx, cx      ; save cx in dx register.

; Generate X random (implementation is here for random)

        mov ax, nrandom_seed    ; ax = seed
        xor dx, dx              ; dx = clear
        mov cx, 62237           ; cx = 62237
        div cx                  ; ax = ax/cx, dx = remainder
        mov cx, ax              ; cx = ax/cx part of division
        mov ax, 16807           ; ax = 16807
        mul dx                  ; ax = ax*dx
        mov dx, cx              ; dx = cx
        mov cx, ax              ; cx = ax*dx
        mov ax, 2836            ; ax = 2836
        mul dx                  ; ax = ax*dx
        sub cx, ax              ; cx = cx-ax
        xor dx, dx              ; dx = clear
        mov ax, cx              ; ax = cx
        mov nrandom_seed, cx    ; set new seed for next time
        mov cx, 225             ; base
        div cx                  ; this is max for random number.

; dx contains random number...
        pop ax
        mov bx, dx      ; bx = random X?
        shr bx, 1       ; bx = rand x/2
        shr bx, 1       ; bx = rand x/4
        add bx, ax      ; bx = (screen length * y) + rand x/4
        mov ax, 0a000h  ; point to display memory, (add 19200 for 2nd page)
        mov es, ax      ; point ES to dispay memory, excuse me...

        mov cx, dx      ; cl = (x)
        and cl, 011b    ; cl = (x AND 011b)
        mov ax, 0102h   ; 
        shl ah, cl
        mov dx, 03c4h
        out dx, ax

        mov al, 05fh    ; color
        mov es:[bx],al  ; DRAW PIXEL at (x,y) in color
        pop cx
        loop here1

; Wait for a keystroke.
        mov     ah,1
        int     21h

; Restore text mode.
        mov     ax,03h
        int     10h

; Display Hello World Message.
        mov dx, offset message
	mov ah, 09
	int 21h

; Return to Dos
        mov ax, 4c00h
	int 21h

end _entry
